000010 IDENTIFICATION DIVISION.
000020*@S              Static subroutine or dnamically called DLL
000030 PROGRAM-ID. SMAIL1.
000040 DATE-COMPILED.
000050* ------------------------: Simple mail demo program
000060*                         : Used to demonstrate GUI-ScreenIO's
000070*                         : mail   API calls.
000080*                         :
000090*                         : Designed to be linked into your
000100*                         : program and to provide a user entery
000110*                         : screen for message text etc.
000120*                         : Called with No arguments.
000130*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000140 ENVIRONMENT DIVISION.
000150*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000160 CONFIGURATION SECTION.
000170 SOURCE-COMPUTER. IBM-PC.
000180 OBJECT-COMPUTER. IBM-PC.
000190*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000200 DATA DIVISION.
000210*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000220 WORKING-STORAGE SECTION.
000230 01  V--VERSION-LEVEL                 PIC 9(3) VALUE 15.
000240* -====-
000250*                         : Copy the base panel
000260         COPY SMAIL000.
000270*                         : Copy values for our API calls
000280         COPY WIN32API.
000290         COPY REGISTRY.
000300         COPY MAILAPI.
000310*
000320*                         : Used to split up email addresses
000330 01  WS-USER-EMAIL-NAME               PIC X(100).
000340 01  WS-USER-EMAIL-DOMAIN             PIC X(100).
000350 01  WS-USER-EMAIL-AT-SIGN            PIC X.
000360* -====-
000370 01  WS-SMAIL-WORKING-FIELDS.
000380     05  SM-YOUR-EMAIL                PIC X(0100) VALUE SPACE.
000390     05  SM-SMTP-SERVER               PIC X(0150) VALUE SPACE.
000400     05  SM-PORT                      PIC 9(4) VALUE 25.
000410     05  SM-YOUR-NAME                 PIC X(50) VALUE SPACE.
000420     05  SM-USE-AUTH                  PIC 9 VALUE 0.
000430       88  SM-USE-AUTH-ON             VALUE 1.
000440       88  SM-USE-AUTH-OFF            VALUE 0.
000450     05  SM-YOUR-LOGIN-NAME           PIC X(50) VALUE SPACE.
000460     05  SM-YOUR-PASSWORD             PIC X(50) VALUE SPACE.
000470*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000480 PROCEDURE DIVISION.
000490*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000500*
000510*                         : First we make our initialization call.
000520     PERFORM 0103-FETCH-SETTINGS.
000530*
000540* ------------------------: Display the test panel.
000550*
000560     PERFORM WITH TEST AFTER
000570           UNTIL SMAIL000-EVENT-CLOSE-WINDOW
000580           OR SMAIL000-EVENT-CLOSE-AND-STOP
000590           OR SMAIL000-CANCEL
000600*
000610       PERFORM 0101-DISPLAY-PANEL
000620*
000630       EVALUATE TRUE
000640         WHEN SMAIL000-SEND
000650           IF SM-PORT NUMERIC AND SM-PORT > 0 AND
000660                 SM-YOUR-EMAIL > SPACE AND
000670                 SM-SMTP-SERVER > SPACE AND
000680                 WS-USER-EMAIL-AT-SIGN = '@' AND
000690                 WS-USER-EMAIL-NAME > SPACE AND
000700                 WS-USER-EMAIL-DOMAIN > SPACE
000710*
000720             IF SM-TO > SPACE AND
000730                   SM-TEXT > SPACE AND
000740                   SM-SUBJECT > SPACE
000750               PERFORM 0104-SEND-MAIL
000760             ELSE
000770               MOVE 'Missing Address, subject, or text' TO
000780                   SMAIL000-MESSAGE-TEXT
000790               SET SMAIL000-MB-STOP-ICON
000800                   SMAIL000-MB-BTN-OK TO TRUE
000810             END-IF
000820           ELSE
000830             MOVE 'INVALID SETTINGS' TO SMAIL000-MESSAGE-TEXT
000840             SET SMAIL000-MESSAGE-IN-MESSAGEBOX TO TRUE
000850           END-IF
000860*
000870       END-EVALUATE
000880*
000890     END-PERFORM.
000900*
000910     STOP RUN.
000920*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000930 0100-GS-UTILITY SECTION.
000940* -====-
000950 0101-DISPLAY-PANEL.
000960     CALL 'GS' USING SMAIL000-1
000970                     SMAIL000-2
000980                     SMAIL000-3
000990                     SMAIL000-4.
001000*
001010 0102-API-CALL.
001020     MOVE 'MailSettings' TO REGISTRY-SUBKEY.
001030     CALL 'GSWINAPI' USING WIN32API-PARMS
001040                           REGISTRY-PARMS
001050                           WIN32API-B
001060                           WIN32API-C
001070                           WIN32API-D
001080                           WIN32API-E
001090                           WIN32API-F.
001100* -====-
001110 0103-FETCH-SETTINGS.
001120     MOVE LOW-VALUES TO
001130         SM-YOUR-EMAIL
001140         SM-SMTP-SERVER
001150         WS-USER-EMAIL-NAME
001160         WS-USER-EMAIL-DOMAIN
001170         WS-USER-EMAIL-AT-SIGN
001180     MOVE 25 TO SM-PORT.
001190*
001200*                         : Upon being initiated, we fetch our
001210*                         : settings from the registry and load
001220*                         : our working storage fields.
001230*                         : First - email address
001240     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001250     MOVE 'Email Address' TO REGISTRY-VALUENAME.
001260     MOVE LOW-VALUES TO REGISTRY-DATA.
001270     SET FUNC-REGISTRY-GET TO TRUE.
001280     PERFORM 0102-API-CALL.
001290     IF NOT WIN32API-FAILED
001300       IF REGISTRY-DATA-LENGTH > ZERO
001310         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001320             TO SM-YOUR-EMAIL.
001330*
001340*                         : Second Smtp server address
001350     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001360     MOVE 'SMTP Server' TO REGISTRY-VALUENAME.
001370     MOVE LOW-VALUES TO REGISTRY-DATA.
001380     SET FUNC-REGISTRY-GET TO TRUE.
001390     PERFORM 0102-API-CALL.
001400     IF NOT WIN32API-FAILED
001410       IF REGISTRY-DATA-LENGTH > ZERO
001420         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001430             TO SM-SMTP-SERVER.
001440*
001450*                         : Fetch the smtp port
001460     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001470     MOVE 'SMTP Port' TO REGISTRY-VALUENAME.
001480     MOVE LOW-VALUES TO REGISTRY-DATA.
001490     SET FUNC-REGISTRY-GET TO TRUE.
001500     PERFORM 0102-API-CALL.
001510     IF NOT WIN32API-FAILED
001520       IF REGISTRY-DATA-LENGTH > ZERO
001530         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001540             TO SM-PORT.
001550*
001560     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001570     MOVE 'User Name' TO REGISTRY-VALUENAME.
001580     MOVE LOW-VALUES TO REGISTRY-DATA.
001590     SET FUNC-REGISTRY-GET TO TRUE.
001600     PERFORM 0102-API-CALL.
001610     IF NOT WIN32API-FAILED
001620       IF REGISTRY-DATA-LENGTH > ZERO
001630         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001640             TO SM-YOUR-NAME.
001650*
001660     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001670     MOVE 'User LOGIN' TO REGISTRY-VALUENAME.
001680     MOVE LOW-VALUES TO REGISTRY-DATA.
001690     SET FUNC-REGISTRY-GET TO TRUE.
001700     PERFORM 0102-API-CALL.
001710     IF NOT WIN32API-FAILED
001720       IF REGISTRY-DATA-LENGTH > ZERO
001730         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001740             TO SM-YOUR-LOGIN-NAME.
001750*
001760     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001770     MOVE 'User PASSWD' TO REGISTRY-VALUENAME.
001780     MOVE LOW-VALUES TO REGISTRY-DATA.
001790     SET FUNC-REGISTRY-GET TO TRUE.
001800     PERFORM 0102-API-CALL.
001810     IF NOT WIN32API-FAILED
001820       IF REGISTRY-DATA-LENGTH > ZERO
001830         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001840             TO SM-YOUR-PASSWORD.
001850*
001860     SET REGISTRY-DATA-IS-TEXT TO TRUE.
001870     MOVE 'Use AUTH' TO REGISTRY-VALUENAME.
001880     MOVE LOW-VALUES TO REGISTRY-DATA.
001890     SET FUNC-REGISTRY-GET TO TRUE.
001900     PERFORM 0102-API-CALL.
001910     IF NOT WIN32API-FAILED
001920       IF REGISTRY-DATA-LENGTH > ZERO
001930         MOVE REGISTRY-DATA (1:REGISTRY-DATA-LENGTH)
001940             TO SM-USE-AUTH.
001950*
001960*                         : break up our address for checking
001970     UNSTRING SM-YOUR-EMAIL DELIMITED '@' INTO
001980         WS-USER-EMAIL-NAME
001990         DELIMITER IN WS-USER-EMAIL-AT-SIGN
002000         WS-USER-EMAIL-DOMAIN.
002010*
002020 0104-SEND-MAIL.
002030*                         :---------------------------------------
002040* ------------------------: SENDING A MESSAGE
002050*                         : Here we build a smtp mail message and
002060*                         : send it.
002070*                         : You should be familiar with the
002080*                         : smtp protocol to follow this code. See
002090*                         : http://rfc.sunsite.dk/rfc/rfc2821.html
002100*                         :---------------------------------------
002110*
002120     MOVE SM-YOUR-NAME TO APM-YOUR-NAME
002130     MOVE SM-YOUR-EMAIL TO APM-YOUR-EMAIL
002140     MOVE SM-SMTP-SERVER TO APM-SMTP-SERVER
002150     MOVE SM-PORT TO APM-PORT
002160     MOVE SM-TO-NAME TO APM-TO-NAME
002170     MOVE SM-TO TO APM-TO-EMAIL
002180     MOVE SM-SUBJECT TO APM-SUBJECT
002190     MOVE SM-TEXT TO APM-TEXT
002200     MOVE SPACE TO APM-AUTHENTICATION
002210     IF SM-USE-AUTH-ON
002220       SET APM-AUTHENTICATE-DESIRED TO TRUE
002230       MOVE SM-YOUR-LOGIN-NAME TO
002240           APM-AUTHENTICATION-USERID
002250       MOVE SM-YOUR-PASSWORD TO
002260           APM-AUTHENTICATION-PASSWORD
002270     END-IF
002280*
002290     SET FUNC-SENDMAIL TO TRUE.
002300     CALL 'GSWINAPI' USING WIN32API-PARMS
002310                           APM-MAIL-PARMS
002320                           WIN32API-B
002330                           WIN32API-C
002340                           WIN32API-D
002350                           WIN32API-E
002360                           WIN32API-F.
002370     IF WIN32API-FAILED
002380       MOVE WIN32API-ERROR-TEXT TO SMAIL000-MESSAGE-TEXT
002390       SET SMAIL000-MESSAGE-BAR-BEEP TO TRUE
002400     ELSE
002410       MOVE 'Message Sent.....' TO SMAIL000-MESSAGE-TEXT
002420       SET SMAIL000-MESSAGE-BAR-SILENT TO TRUE.
